import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsUsercourserecord {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  UserId!: IType<number, bigint>;
  CourseId!: IType<number, bigint>;
  ViewTime!: number;
  ViewTotal!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsUsercourserecordSchema = defineEntity({
  class: ScsUsercourserecord,
  comment: '课程观看记录',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    UserId: p.bigint().name('UserId').columnType('bigint').comment('用户id'),
    CourseId: p.bigint().name('CourseId').columnType('bigint').comment('课程id'),
    ViewTime: p.integer().name('ViewTime').comment('观看时间'),
    ViewTotal: p.integer().name('ViewTotal').comment('观看次数'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
